// Ex_p5_Audio19_Record.js modifie
// 29-10-2018
// Pour p5.js (Processing en JavaScript)
// OK Processing v 3.3.7 en mode p5.js
// OK en local Firefox Chrome Opera
// Pb en local Safari
// 
// Utilise la library p5.js
// Utilise la library p5.dom.js
// Utilise la library p5.sound.jrs
//
// /p5jsMode/examples/Sound/ex19_Record_Save/ex19_Record_Save.js
// https://p5js.org/reference/#/p5.SoundRecorder
// https://p5js.org/reference/#/p5.SoundFile
// https://p5js.org/reference/#/p5.SoundFile/save NON 
// https://p5js.org/reference/#/p5.SoundRecorder/saveSound
// https://p5js.org/reference/#/p5/saveSound
// https://p5js.org/reference/#/p5.Amplitude
// https://github.com/processing/p5.js-sound/tree/master/examples

var TitrePage = "Ex_p5_Audio19_Record";
var Micro, recorder, Parole, peaks, MicroLevel;
var Bord = 50, BordX = 350; // pixels
var PetitBord = 5; // pixels
var BoutonRec = new Array(3);
var EnTrainDEnregistrer = false;
var EnTrainDeJouer = false;
var Saved = false;
var NomFichier = "O";
var Canaux = "";

function setup() {
  createElement('title', TitrePage);
  Canevas = createCanvas(400, 400);
  Canevas.position(BordX, Bord);

  CouleurVerte = color(50, 150, 50);
  CouleurGrise = color(200);
  CouleurFond = CouleurGrise;
  fill(0);

  //Texte1 = createElement('h2', '');
  //Texte1.position(20, -10);
  //Texte1.html(TitrePage);

  for (var i = 0; i < BoutonRec.length; i++) {
    BoutonRec[i] = createButton('');
    BoutonRec[i].style('background-color', CouleurVerte);
    BoutonRec[i].style('color', color(255, 255, 255));
    BoutonRec[i].style('font-size', '16px');
    BoutonRec[i].style('border', 'none');
    BoutonRec[i].style('border-radius', '6px');
    BoutonRec[i].position(BordX + 5 + (i * 120), Bord + 5);
    BoutonRec[i].size(110, 30);
  }
  BoutonRec[0].html('Record');
  BoutonRec[0].style('background-color', color(255, 0, 0)); // Rouge
  BoutonRec[0].mouseClicked(ClicBoutonRecord);
  BoutonRec[1].html('Play');
  BoutonRec[1].mouseClicked(ClicBoutonPlay);
  BoutonRec[2].html('Save');
  BoutonRec[2].mouseClicked(ClicBoutonSave);

  Micro = new p5.AudioIn();            // create an audio in
  Micro.start();                       // users must manually enable their browser microphone for recording
  recorder = new p5.SoundRecorder(); // create a sound recorder
  recorder.setInput(Micro);            // connect Micro to recorder
  Parole = new p5.SoundFile();    // create an empty sound file
  Parole.playMode('restart');
  analyse = new p5.Amplitude(0.90); // create a new Amplitude analyse
  analyse.setInput(Micro);

  rectMode(CORNERS);
  background(CouleurFond);
  frameRate(10);
  DessinRectangle();
}

function draw() {
  // background(CouleurFond);
  // fill(0);text("Frame = " + frameCount, 10, 80);
  if (Parole.isPlaying()) {
    noStroke();
    fill(CouleurGrise);
    rect(0, height - 40, 100, height - 20);
    textAlign(RIGHT);
    textSize(14);
    fill(CouleurVerte);
    text(int(Parole.currentTime()) + " sec", PetitBord + 60, height - 25);
    var xxx = int((width - (2 * PetitBord)) * Parole.currentTime() / Parole.duration()) + PetitBord;
    //stroke(CouleurVerte);
    //line(xxx, 40, xxx, height - PetitBord);
    fill(CouleurGrise);
    rect(PetitBord, 40, width - PetitBord, 45);
    fill(CouleurVerte);
    rect(PetitBord, 40, xxx, 45);
    //fill(200);
    //rect(PetitBord + 100, height - 10, PetitBord + 200, height - 20);
    //fill(CouleurVerte);
    //textAlign(LEFT);
    //textSize(14);
    //text(int(Parole.currentTime()) + "/" + max(int(Parole.duration()), 1) + " sec", PetitBord + 100, height - 10);
  } else StopPlay();

  if (EnTrainDEnregistrer) {
    // noStroke();
    // CouleurFond = color(255, 0, 0); // red
    // background(CouleurFond);
    DessinRectangle();
    fill(CouleurVerte);
    // MicroLevel = int(Micro.getLevel() * 2000);
    MicroLevel = int(analyse.getLevel() * 700);
    textSize(36);
    textAlign(CENTER);
    // text("RMS level: " + MicroLevel + " ", 20, 140);
    // var yy = height - PetitBord - constrain(MicroLevel, 0, height);
    var yy = height - 40 - constrain(MicroLevel * 3, 0, 270);
    // rect(PetitBord, height - PetitBord, width - PetitBord, yy);
    rect(width / 2 - 10, height - 40, width / 2 + 10, yy);
    text(int(MicroLevel), width / 2, yy - 5);
    fill(CouleurFond);
    // rect(PetitBord, yy, width - PetitBord, 40);
  }
}

function ClicBoutonRecord() {
  if (EnTrainDeJouer) StopPlay();
  if (EnTrainDEnregistrer) {
    StopRecord();
    var soundBlob = Parole.getBlob();
    console.log("soundBlob = " + soundBlob + "  soundBlob.size = " + soundBlob.size);
    // var machin = blobToFile(soundBlob, '/Users/g/Desktop/machin.wav');
    var machin = blobToFile(soundBlob, 'machin.wav');
    console.log("blobToFile " + machin + "  machin.name = " + machin.name + "  machin.lastModifiedDate = " + machin.lastModifiedDate );
    console.log("machin.size = " + machin.size);
    // NomFichier = 'Capsule-' + year() + '-' + month() + '-' + day() + '-' + hour() + 'h' + minute() + '.wav';
    // saveSound(machin, NomFichier); // save file
    // saveBlob(machin, NomFichier); // save file
  } else if (Micro.enabled) {
    BoutonRec[0].html('Stop Record');
    Envoyer(4, 'Stop Record');
    recorder.record(Parole);
    CouleurFond = color(255, 0, 0); // red
    background(CouleurFond);
    DessinRectangle();
    EnTrainDEnregistrer = true;
    Saved = false;
  }
  // return false; // https://p5js.org/reference/#/p5/mouseClicked
}

function blobToFile(theBlob, fileName) {
  //A Blob() is almost a File() - it's just missing the two properties below which we will add
  theBlob.lastModifiedDate = new Date();
  theBlob.name = fileName;
  return theBlob;
}

function ClicBoutonPlay() {
  if (EnTrainDEnregistrer) StopRecord();
  if (EnTrainDeJouer) StopPlay();
  else {
    EnTrainDeJouer = true;
    BoutonRec[1].html('Stop Play');
    Envoyer(5, 'Stop Play');
    Parole.stop(); 
    Parole.play(); // play the result!
  }
  // return false; // https://p5js.org/reference/#/p5/mouseClicked
}

function ClicBoutonSave() {
  if (EnTrainDEnregistrer) StopRecord();
  if (EnTrainDeJouer) StopPlay();
  NomFichier = 'Capsule-' + year() + '-' + month() + '-' + day() + '-' + hour() + 'h' + minute() + '.wav';
  saveSound(Parole, NomFichier); // save file
  // Parole.save(NomFichier); // Ne fonctionne pas
  Saved = true;
  Dessin();
  // return false; // https://p5js.org/reference/#/p5/mouseClicked
}

function StopRecord() {
  EnTrainDEnregistrer = false;
  recorder.stop();
  BoutonRec[0].html('Record');
  Envoyer(4, 'Record');
  Dessin();
}

function StopPlay() {
  Parole.stop();
  if (EnTrainDeJouer) {
    EnTrainDeJouer = false;
    BoutonRec[1].html('Play');
    Envoyer(5, 'Play');
  }
}

function Dessin() {
  CouleurFond = CouleurGrise;
  DessinRectangle();
  peaks = Parole.getPeaks(); 
  stroke(CouleurVerte);
  beginShape();
  for (i = 0; i < peaks.length; i = i + 1) vertex(map(i, 0, peaks.length, PetitBord, width - PetitBord), map(peaks[i], -1, 1, height - 40, 40));
  endShape();
  noStroke();
  fill(CouleurVerte);
  // fill(0);
  textAlign(LEFT);
  textSize(14);
  if (Parole.channels() == 1) Canaux = "Mono  ";
  if (Parole.channels() == 2) Canaux = "Stereo  ";
  // Canaux = Canaux + peaks.length + "  ";
  text(Canaux, width - PetitBord - 80, height - 6);
  text(max(int(Parole.duration()), 1) + " sec", width - PetitBord - 80, height - 24);
  if (Saved) text(NomFichier + " sauvé ", PetitBord + 10, height - 6);
}

function DessinRectangle() {
  noStroke();
  background(CouleurFond);
  fill(255);
  rect(PetitBord, 40, width - PetitBord, height - 40, 5);
  // line(PetitBord, (height - PetitBord) / 2 + 20, width - PetitBord, (height - PetitBord) / 2 + 20);
}
